Declare ReadIn(File$)
Structure Line
  Activ.l
  s.s
EndStructure
Structure ProcedureList
  s.s
  Start.l
  Ende.l
EndStructure

Global ReadFileNr.l
Global IPath.s,CurrentPath.s
Global line,depth
line=-1

NewList IncludeFileList.STRING()
NewList Quellcode.Line()
NewList ProcedureList.ProcedureList()
NewList Activate.Line()

Dim IncludeList.s(100)
Global IncludeList:IncludeList=-1

Dim Chars(255)
For i='a' To 'z':Chars(i)=#True:Next
For i='A' To 'Z':Chars(i)=#True:Next
For i='0' To '9':Chars(i)=#True:Next:Chars('_')=#True

Procedure.s derelativ_path(in1$,in2$)
  If Left(in2$,2)="\\" Or FindString(in2$,":",1)
    ProcedureReturn in2$
  EndIf
  If Left(in1$,2)="\\"
    in1$="*:"+Right(in1$,Len(in1$)-2)
  EndIf
  If Left(in2$,2)="\\"
    in2$="*:"+Right(in2$,Len(in2$)-2)
  EndIf
  out$=""
  If Left(in2$,1)="\"
    in2$=Left(in1$,FindString(in1$,":",1))+in2$
  ElseIf Right(StringField(in2$,1,"\"),1)<>":"
    an=1:quit=0
    Repeat
      If StringField(in1$,an,"\")<>""
        an+1
      Else
        quit=1
      EndIf
    Until quit
    quit=0
    Repeat
      If Left(in2$,3)="..\"
        an-1
        in2$=Mid(in2$,4,Len(in2$)-3)
      Else
        quit=1
      EndIf
    Until quit
    For i=1 To an-1
      out$+StringField(in1$,i,"\")+"\"
    Next
  EndIf
  out$+in2$
  ProcedureReturn ReplaceString(out$,"*:","\\")
EndProcedure
Procedure.s DeRelativName(in1$,in2$)
  ProcedureReturn derelativ_path(GetPathPart(in1$),GetPathPart(in2$))+GetFilePart(in2$)
EndProcedure

Procedure Find_ProcedureList(*name.BYTE)
  ResetList(ProcedureList())
  half=CountList(ProcedureList())>>1
  If half
    SelectElement(ProcedureList(),half)
    Pos=half
    quit=0
  Else
    Pos=0
    If NextElement(ProcedureList())=0
      quit=2
    Else
      quit=0
    EndIf
  EndIf
  oldcompare=0
  While quit=0
    compare=CompareMemoryString(*name,@ProcedureList()\s,1)
    If half
      Select compare
        Case -1:half>>1:Pos-half:SelectElement(ProcedureList(),Pos)
        Case 0:quit=1
        Case 1:half>>1:Pos+half:SelectElement(ProcedureList(),Pos)
      EndSelect
    Else
      If compare=0
        quit=1
      ElseIf compare=oldcompare Or oldcompare=0
        oldcompare=compare
        If compare=-1
          If PreviousElement(ProcedureList())=0
            ResetList(ProcedureList())
            quit=2
          EndIf
        Else
          If NextElement(ProcedureList())=0
            LastElement(ProcedureList())
            quit=2
          EndIf
        EndIf
      Else
        If oldcompare=1
          If PreviousElement(ProcedureList())=0
            ResetList(ProcedureList())
          EndIf
        EndIf
        quit=2
      EndIf
    EndIf    
  Wend
  If quit=2
    ProcedureReturn 0
  Else
    ProcedureReturn 1
  EndIf  
EndProcedure
Procedure Find_Activate(*name.BYTE)
  ResetList(Activate())
  half=CountList(Activate())>>1
  If half
    SelectElement(Activate(),half)
    Pos=half
    quit=0
  Else
    Pos=0
    If NextElement(Activate())=0
      quit=2
    Else
      quit=0
    EndIf
  EndIf
  oldcompare=0
  While quit=0
    compare=CompareMemoryString(*name,@Activate()\s,1)
    If half
      Select compare
        Case -1:half>>1:Pos-half:SelectElement(Activate(),Pos)
        Case 0:quit=1
        Case 1:half>>1:Pos+half:SelectElement(Activate(),Pos)
      EndSelect
    Else
      If compare=0
        quit=1
      ElseIf compare=oldcompare Or oldcompare=0
        oldcompare=compare
        If compare=-1
          If PreviousElement(Activate())=0
            ResetList(Activate())
            quit=2
          EndIf
        Else
          If NextElement(Activate())=0
            LastElement(Activate())
            quit=2
          EndIf
        EndIf
      Else
        If oldcompare=1
          If PreviousElement(Activate())=0
            ResetList(Activate())
          EndIf
        EndIf
        quit=2
      EndIf
    EndIf    
  Wend
  If quit=2
    ProcedureReturn 0
  Else
    ProcedureReturn 1
  EndIf  
EndProcedure
Procedure Find_IncludeFileList(*name.BYTE)
  ResetList(IncludeFileList())
  half=CountList(IncludeFileList())>>1
  If half
    SelectElement(IncludeFileList(),half)
    Pos=half
    quit=0
  Else
    Pos=0
    If NextElement(IncludeFileList())=0
      quit=2
    Else
      quit=0
    EndIf
  EndIf
  oldcompare=0
  While quit=0
    compare=CompareMemoryString(*name,@IncludeFileList()\s,1)
    If half
      Select compare
        Case -1:half>>1:Pos-half:SelectElement(IncludeFileList(),Pos)
        Case 0:quit=1
        Case 1:half>>1:Pos+half:SelectElement(IncludeFileList(),Pos)
      EndSelect
    Else
      If compare=0
        quit=1
      ElseIf compare=oldcompare Or oldcompare=0
        oldcompare=compare
        If compare=-1
          If PreviousElement(IncludeFileList())=0
            ResetList(IncludeFileList())
            quit=2
          EndIf
        Else
          If NextElement(IncludeFileList())=0
            LastElement(IncludeFileList())
            quit=2
          EndIf
        EndIf
      Else
        If oldcompare=1
          If PreviousElement(IncludeFileList())=0
            ResetList(IncludeFileList())
          EndIf
        EndIf
        quit=2
      EndIf
    EndIf    
  Wend
  If quit=2
    ProcedureReturn 0
  Else
    ProcedureReturn 1
  EndIf  
EndProcedure
Procedure AusSpacen(*start,*ende)
  For *i.BYTE=*Start To *Ende
    If *i\b
      *i\b=' '
    EndIf
  Next
EndProcedure
Procedure Test_Quellcode(Flag); 1= Procedurescan 0= Include
  
  *buf.BYTE=@Quellcode()\s
  While *buf\b
    While *buf\b=' ' Or *buf\b=8 : *buf+1 : Wend
    *WordStart=*buf
    While Chars(*buf\b & $FF) : *buf+1 : Wend
    WordLen=*buf-*WordStart
    While *buf\b=' ' Or *buf\b=8 : *buf+1 : Wend
    
    Select *buf\b
      Case '('
        If Flag
          If WordLen
            c$=PeekS(*WordStart,WordLen)
            If Find_Activate(@c$)=0
              AddElement(Activate())
              Activate()\s=c$
              Activate()\Activ=0
            EndIf
          EndIf
        EndIf
        *buf+1
      Case '.'
        *buf+1
        While Chars(*buf\b & $FF) : *buf+1 : Wend
      Case 39
        *buf+1
        While *buf\b<>39 And *buf\b<>0
          *buf+1
        Wend
        If *buf\b=39:*buf+1:EndIf
      Case '"'
        ;XIncludeFile
        ;IncludeFile
        ;IncludePath
        *buf+1
        *FileName=*buf
        While *buf\b<>'"' And *buf\b<>0
          *buf+1
        Wend
        a$=PeekS(*FileName,*buf-*FileName)
        If *buf\b='"':*buf+1:EndIf
        ;Debug Str(Flag)+" "+a$
        If Flag=0
          If WordLen=12
            If CompareMemoryString(*WordStart,"XINCLUDEFILE",#True,12)=0
              If Left(a$,1)<>"\"
                a$=IPath+a$
              EndIf  
              a$=DeRelativName(CurrentPath,a$)
              AusSpacen(*WordStart,*buf)
              If Find_IncludeFileList(@a$)=0
                AddElement(IncludeFileList())
                IncludeFileList()\s=a$
                ReadIn(a$)
              EndIf
              
            EndIf
          ElseIf WordLen=11
            If CompareMemoryString(*WordStart,"INCLUDEFILE",#True,11)=0
              If Left(a$,1)<>"\"
                a$=IPath+a$
              EndIf  
              a$=DeRelativName(CurrentPath,a$)
              AusSpacen(*WordStart,*buf)
              If Find_IncludeFileList(@a$)=0
                AddElement(IncludeFileList())
                IncludeFileList()\s=a$
              EndIf
              ReadIn(a$)
            ElseIf CompareMemoryString(*WordStart,"INCLUDEPATH",#True,11)=0
              ;AusSpacen(*WordStart,*buf)
              IPath=a$
              If Right(IPath,1)<>"\"
                IPath+"\"
              EndIf
            EndIf
          EndIf
        EndIf
      Case 0;nothing
      Default
        c$=PeekS(*WordStart,WordLen)
        If UCase(c$)="DECLARE"
          While *buf\b And *buf\b<>':'
            *buf+1
          Wend
        EndIf
        
        
        If *buf\b<>';' And Chars(*buf\b &$FF)=0
          *buf+1
        EndIf
    EndSelect
    If *buf\b=';'
      Break
    EndIf
  Wend
EndProcedure
Procedure ScanForProcedures()
  line=0
  LastProc$=""
  Activ=#True
  ForEach Quellcode()
    If CompareMemoryString(@Quellcode()\s,"PROCEDURE ",#True,10)=0 Or CompareMemoryString(@Quellcode()\s,"PROCEDURE.",#True,10)=0
      Activ=#False
      b=FindString(Quellcode()\s,"(",0)
      If b
        xx=FindString(Quellcode()\s," ",10)
        LastProc$=Trim(Mid(Quellcode()\s,xx,b-xx))
        If Find_ProcedureList(@LastProc$)=0
          AddElement(ProcedureList())
          ProcedureList()\s=LastProc$
          ProcedureList()\Start=line
        EndIf
      EndIf
    EndIf
    
    Quellcode()\Activ=Activ
    If Activ
      Test_Quellcode(#True)
    EndIf
    
    If CompareMemoryString(Quellcode()\s,"ENDPROCEDURE",#True,12)=0
      Activ=#True
      If Find_ProcedureList(@LastProc$)
        ProcedureList()\Ende=line
      EndIf
    EndIf
    line+1
  Next
EndProcedure

Procedure ReadIn(File$)
  depth+1
  PrintN("Read:"+File$)
  If API_FileRead(file.API_FileHandle,File$)
    While API_EOF(file)=#False
      b$=Trim(API_ReadString(file))
      doit=#True
      If Left(b$,1)=";"
        do=#True
        If b$ = "; EOF"
        ElseIf Left(b$,19) = "; Manual Parameter="
        ElseIf      b$     = "; Manual do Advanced"
        ElseIf Left(b$,8)  = "; Build="
        ElseIf Left(b$,10) = "; Include="
          If depth=1 And IncludeList<100
            IncludeList+1
            IncludeList(IncludeList)=Right(b$,Len(b$)-10)
          EndIf
          doit=#False
        ElseIf Left(b$,16) = "; ResourceType3="
        ElseIf Left(b$,16) = "; ResourceType2="
        ElseIf Left(b$,15) = "; ResourceType="
        ElseIf Left(b$,15) = "; ResourceName="
        ElseIf Left(b$,19) = "; ResourceLanguage="
        ElseIf Left(b$,15) = "; ResourceFile="
        ElseIf Left(b$,20) = "; Working Directory="
        ElseIf b$=           "; Enable Multiple Icon"
        ElseIf b$=           "; Include Manifest"
        ElseIf Left(b$,14) = "; ProductName="
        ElseIf Left(b$,17) = "; ProductVersion="
        ElseIf Left(b$,15) = "; SpecialBuild="
        ElseIf Left(b$,15) = "; PrivateBuild="
        ElseIf Left(b$,18) = "; LegalTrademarks="
        ElseIf Left(b$,15) = "; AddInfo1Text="
        ElseIf Left(b$,11) = "; AddInfo1="
        ElseIf Left(b$,15) = "; AddInfo2Text="
        ElseIf Left(b$,11) = "; AddInfo2="
        ElseIf Left(b$,14) = "; CompanyName="
        ElseIf Left(b$,18) = "; FileDescription="
        ElseIf Left(b$,14) = "; FileVersion="
        ElseIf Left(b$,15) = "; InternalName="
        ElseIf Left(b$,17) = "; LegalCopyright="
        ElseIf Left(b$,19) = "; OriginalFilename="
        ElseIf Left(b$, 8) = "; EMail="
        ElseIf Left(b$, 6) = "; Web="
        ElseIf Left(b$,11) = "; Comments="
        ElseIf Left(b$,11) = "; Language="
        ElseIf b$ =          "; EnableNT4"
        ElseIf b$ =          "; EnableAsm"
        ElseIf b$ =          "; EnableXP"
        ElseIf b$ =          "; DisableDebugger"
        ElseIf b$ =          "; SaveDeclare":b$ = "; DontSaveDeclare"
        ElseIf b$ =          "; DontSaveDeclare"
        ElseIf b$ =          "; EnableOnError"
        ElseIf Left(b$,19) = "; ExecutableFormat="
        ElseIf Left(b$,16) = "; jaPBe Version="
        ElseIf Left(b$,12) = "; FoldLines=":doit=#False
        ElseIf Left(b$,14) = "; CompileThis="
        ElseIf Left(b$,13) = "; Executable="
        ElseIf Left(b$,14) = "; CommandLine="
        ElseIf Left(b$,10) = "; UseIcon="
        ElseIf Left(b$,6)  = "; CPU="
        ElseIf Left(b$,17) = "; CursorPosition=":doit=#False
        ElseIf Left(b$,12) = "; FirstLine=":doit=#False
        Else : do=#False
        EndIf
        If do And depth>1
          doit=#False
        EndIf
      EndIf
      If doit
        AddElement(Quellcode())
        Quellcode()\Activ=Activ
        Quellcode()\s=b$
        Test_Quellcode(#False)
      EndIf
    Wend
    line-1
    API_CloseFile(file)
  EndIf
  depth-1
EndProcedure


;-Global
Global jaPBe_Handle
Global jaPBe_Version

Global jaPBe_CompilerMsg.s
Global jaPBe_CompilerType
Global jaPBe_FileName.s
Global jaPBe_Selection
Global jaPBe_CurrentWord
Global jaPBe_CompleteText
Global jaPBe_CurrentLine
Global jaPBe_IncludePath.s

#timeout=5000

;-Window-Message
#mywm_Plugin_GetCurrentFileName = #WM_USER+12
#mywm_Plugin_GetSelection       = #WM_USER+13
#mywm_Plugin_GetCurrentWord     = #WM_USER+14
#mywm_plugin_GetCompleteText    = #WM_USER+15
#mywm_plugin_GetCurrentLine     = #WM_USER+16
#mywm_plugin_GetCurrentPosition = #WM_USER+17
#mywm_Plugin_Cancel             = #WM_USER+18
#mywm_plugin_DisablejaPBe       = #WM_USER+19
#mywm_plugin_EnablejaPBe        = #WM_USER+20
#mywm_Plugin_CompileRun         = #WM_USER+21
#mywm_plugin_Run                = #WM_USER+22
#mywm_plugin_CreateExecutable   = #WM_USER+23
#mywm_plugin_GetCompileThis     = #WM_USER+24
#mywm_Plugin_GetIncludePackPath = #WM_USER+25
#mywm_Plugin_IncreaseBuild      = #WM_USER+26
#mywm_plugin_SaveAll            = #WM_USER+27
#mywm_plugin_Save               = #WM_USER+28

;-Window-CopyData
#WMCD_OpenFile            = 1
#WMCD_InsertText          = 2
#wmCD_ReplaceCompleteText = 3
#wmcd_ReplaceCurrentLine  = 4
#wmcd_NewText             = 5
#wmcd_Fatal_Error         = 6
#wmcd_Assembler_Error     = 7
#wmcd_Linker_Error        = 8
#wmcd_Syntax_Error        = 9
#wmcd_Compilation_Finished=10

#comp_Fatal_Error         = 6
#comp_Assembler_Error     = 7
#comp_Linker_Error        = 8
#comp_Syntax_Error        = 9
#comp_Compilation_Finished=10

Procedure SendDataS(ziel,Type,Message$)
  cd.COPYDATASTRUCT
  cd\dwData=Type
  cd\cbData=Len(Message$)+1
  cd\lpData=@Message$
  ProcedureReturn SendMessage_(ziel,#wm_copydata,WindowID(1),cd)
EndProcedure
Procedure SendData(ziel,Type,adr,len)
  cd.COPYDATASTRUCT
  cd\dwData=Type
  cd\cbData=len
  cd\lpData=adr
  ProcedureReturn SendMessage_(ziel,#wm_copydata,WindowID(1),cd)
EndProcedure

Procedure Callback(WindowId, Message, wParam, lParam) 
  Result = #PB_ProcessPureBasicEvents 
  If Message=#WM_COPYDATA
    *cd.COPYDATASTRUCT=lParam
    Result=#FALSE
    If wParam=jaPBe_Handle
      Select *cd\dwData
        Case #mywm_Plugin_GetIncludePackPath
          jaPBe_IncludePath=PeekS(*cd\lpData)
          Result=#True
        Case #mywm_plugin_GetCompileThis
          jaPBe_FileName=PeekS(*cd\lpData)
          Result=#True
        Case #mywm_Plugin_GetCurrentFileName
          jaPBe_FileName=PeekS(*cd\lpData)
          Result=#True
        Case #mywm_Plugin_GetSelection
          jaPBe_Selection=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_Selection
            CopyMemory(*cd\lpData,jaPBe_Selection,*cd\cbData)
            Result=#True
          EndIf
        Case #mywm_Plugin_GetCurrentWord
          jaPBe_CurrentWord=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_CurrentWord
            CopyMemory(*cd\lpData,jaPBe_CurrentWord,*cd\cbData)
            Result=#True
          EndIf
        Case #mywm_plugin_GetCompleteText
          jaPBe_CompleteText=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_CompleteText
            CopyMemory(*cd\lpData,jaPBe_CompleteText,*cd\cbData)
            Result=#True
          EndIf
        Case #mywm_plugin_GetCurrentLine
          jaPBe_CurrentLine=GlobalAlloc_(#GMEM_FIXED,*cd\cbData)
          If jaPBe_CurrentLine
            CopyMemory(*cd\lpData,jaPBe_CurrentLine,*cd\cbData)
            Result=#True
          EndIf
        Default
          If *cd\dwData>=#wmcd_Fatal_Error And *cd\dwData<=#wmcd_Compilation_Finished
            jaPBe_CompilerMsg=PeekS(*cd\lpData,*cd\cbData)
            If jaPBe_CompilerMsg=Chr(255)
              jaPBe_CompilerMsg=""
            EndIf
            jaPBe_CompilerType=*cd\dwData
            Result=#True
          EndIf
      EndSelect
    Else
      MessageRequester("jaPBe-Plugin","I got a message NOT from jaPBe!")
    EndIf
  EndIf
  
  ProcedureReturn Result 
EndProcedure 
;-Send
Procedure jaPBe_OpenFile(File$) ; Open the given File in jaPBe
  SendDataS(jaPBe_Handle,#WMCD_OpenFile,File$)
EndProcedure
Procedure jaPBe_InsertTextS(text$) ; Insert the Text in the current Source Code
  SendDataS(jaPBe_Handle,#WMCD_InsertText,Text$) 
EndProcedure
Procedure jaPBe_InsertText(adr,len) ; Insert the Text in the current Source Code
  SendData(jaPBe_Handle,#WMCD_InsertText,adr,len)
EndProcedure
Procedure jaPBe_ReplaceTextS(text$) ; Replace the complete Text in the current Source Code
  SendDataS(jaPBe_Handle,#wmCD_ReplaceCompleteText,Text$)
EndProcedure
Procedure jaPBe_ReplaceText(adr,len) ; Replace the complete Text in the current Source Code
  SendData(jaPBe_Handle,#wmCD_ReplaceCompleteText,adr,len)
EndProcedure
Procedure jaPBe_ReplaceCurrentLineS(text$) ; Replace the current Line in the current Source Code
  SendDataS(jaPBe_Handle,#wmcd_ReplaceCurrentLine,Text$)
EndProcedure
Procedure jaPBe_ReplaceCurrentLine(adr,len) ; Replace the current Line in the current Source Code
  SendData(jaPBe_Handle,#wmcd_ReplaceCurrentLine,adr,len)
EndProcedure
Procedure jaPBe_NewTextS(text$) ; Open in jaPBe a new text and fill it with the text
  SendDataS(jaPBe_Handle,#wmcd_NewText,Text$)
EndProcedure
Procedure jaPBe_NewText(adr,len) ; Open in jaPBe a new text and fill it with the text
  SendData(jaPBe_Handle,#wmcd_NewText,adr,len)
EndProcedure
Procedure jaPBe_EnablejaPBe() ; Enable that the user can control jaPBe
  ProcedureReturn PostMessage_(jaPBe_Handle,#mywm_plugin_EnablejaPBe,0,WindowID(1))
EndProcedure
Procedure jaPBe_DisablejaPBe() ; Disable any User-control over jaPBe
  ProcedureReturn PostMessage_(jaPBe_Handle,#mywm_plugin_DisablejaPBe,0,WindowID(1))
EndProcedure
Procedure jaPBe_SaveAll() ; Save all open Source
  ProcedureReturn SendMessage_(jaPBe_Handle,#mywm_plugin_SaveAll,0,WindowID(1))
EndProcedure
Procedure jaPBe_Save() ; Save Current File
  ProcedureReturn SendMessage_(jaPBe_Handle,#mywm_plugin_Save,0,WindowID(1))
EndProcedure
;-Get
;Waring: This routines use windowevent(), so maybe you lost messages
Procedure.s jaPBe_GetIncludePackPath() ; Returns the path to the Include-Pack
  jaPBe_IncludePath=""
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetIncludePackPath,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_IncludePath<>"" Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_IncludePath
EndProcedure 
Procedure.s jaPBe_GetCurrentFileName() ; Returns the Current file name (String)
  jaPBe_FileName=""
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetCurrentFileName,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_FileName<>"" Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_FileName
EndProcedure
Procedure.s jaPBe_GetCompileThis() ; Returns the CompileThis file or "" (String)
  jaPBe_FileName=""
  If SendMessage_(jaPBe_Handle,#mywm_plugin_GetCompileThis,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_FileName<>"" Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_FileName
EndProcedure
Procedure jaPBe_GetSelection() ; Returns a address with the selected Text or 0, if no Text selected
  If jaPBe_Selection
    GlobalFree_(jaPBe_Selection)
    jaPBe_Selection=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetSelection,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_Selection Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_Selection
EndProcedure
Procedure.s jaPBe_GetSelectionS() ; Returns a String with the selected Text
  Result=jaPBe_GetSelection()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCurrentWord() ; Returns a address with the Word under the cursor or 0 if no word under the cursor
  If jaPBe_CurrentWord
    GlobalFree_(jaPBe_CurrentWord)
    jaPBe_Selection=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_GetCurrentWord,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_CurrentWord Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_CurrentWord
EndProcedure
Procedure.s jaPBe_GetCurrentWordS() ; Returns a String with the Word under the cursor or 0 if no word under the cursor
  Result=jaPBe_GetCurrentWord()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCompleteText() ; Returns a address with the complete text or 0 if no text
  If jaPBe_CompleteText
    GlobalFree_(jaPBe_CompleteText)
    jaPBe_CompleteText=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_plugin_GetCompleteText,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_CompleteText Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_CompleteText
EndProcedure
Procedure.s jaPBe_GetCompleteTextS() ; Returns a String with the complete text
  Result=jaPBe_GetCompleteText()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure jaPBe_GetCurrentLine() ; Returns a address with the current line or 0, if the line is empty
  If jaPBe_CurrentLine
    GlobalFree_(jaPBe_CurrentLine)
    jaPBe_CurrentLine=0
  EndIf
  If SendMessage_(jaPBe_Handle,#mywm_plugin_GetCurrentLine,0,WindowID(1))
    timeout=gettickcount_()+#timeout ;maximal 5 sekunden warten
    Repeat
      WindowEvent()
      Delay(1)
    Until jaPBe_CurrentLine Or gettickcount_()>timeout
  EndIf
  ProcedureReturn jaPBe_CurrentLine
EndProcedure
Procedure.s jaPBe_GetCurrentLineS() ; Returns a String with the current line
  Result=jaPBe_GetCurrentLine()
  If Result
    ProcedureReturn PeekS(Result)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure WaitForCompilerMsg_()
  Repeat
    WindowEvent():Delay(100)
  Until jaPBe_CompilerType
EndProcedure
Procedure jaPBe_CompileRun() ; Compile and Run the current SourceCode 0=Error, returns #comp_...; jaPBe_CompilerMsg contains message
  jaPBe_CompilerType=0
  If SendMessage_(jaPBe_Handle,#mywm_Plugin_CompileRun,0,WindowID(1))
    WaitForCompilerMsg_()
  EndIf
  ProcedureReturn jaPBe_CompilerType
EndProcedure
Procedure jaPBe_Run() ; Run the last compiled SourceCode 0=Error
  ProcedureReturn SendMessage_(jaPBe_Handle,#mywm_plugin_Run,0,WindowID(1))
EndProcedure
Procedure jaPBe_CreateExecutable() ; Create a Executable 0=Error, returns #comp_; jaPBe_CompilerMsg contains message
  jaPBe_CompilerType=0
  If SendMessage_(jaPBe_Handle,#mywm_plugin_CreateExecutable,0,WindowID(1))
    WaitForCompilerMsg_()
  EndIf
  ProcedureReturn jaPBe_CompilerType
EndProcedure
Procedure jaPBe_IncreaseBuild() ; Increase the build-counter of the current-main-file
  ProcedureReturn SendMessage_(jaPBe_Handle,#mywm_Plugin_IncreaseBuild,0,WindowID(1))
EndProcedure
;get without windowevent
Procedure jaPBe_GetCurrentPos()
  ProcedureReturn SendMessage_(jaPBe_Handle,#mywm_plugin_GetCurrentPosition,0,WindowID(1))
EndProcedure

If OpenWindow(1,0,200,200,200,#PB_Window_Invisible,"jaPBe-Plugin Cutter")
  SetWindowCallback(@Callback())
  a$=ProgramParameter()
  If a$="jaPBe"
    jaPBe_Handle=Val(ProgramParameter())
    jaPBe_Version$=ProgramParameter()
    
    ;- here is space for your plugin
    XIncludeFile "cutter.pbi"

    ;Important: Never delete the follow line!
    PostMessage_(jaPBe_Handle,#mywm_Plugin_Cancel,0,WindowID(1))
  Else
    MessageRequester("jaPBe Plugin Cutter","This is a jaPBe-Plugin"+Chr(10)+"You can't run it without jaPBe",0)
  EndIf
  CloseWindow(1)
Else
  MessageRequester("jaPBe Plugin Cutter","Can't open a window!",0)
EndIf

;Free some stuff
If jaPBe_Selection
  GlobalFree_(jaPBe_Selection)
EndIf
If jaPBe_CurrentWord
  GlobalFree_(jaPBe_CurrentWord)
EndIf
If jaPBe_CompleteText
  GlobalFree_(jaPBe_CompleteText)
EndIf
If jaPBe_CurrentLine
  GlobalFree_(jaPBe_CurrentLine)
EndIf

End